module NQueens(
  NQueens(NQueens)
) where

import GA
import Data.List(intercalate, intersperse)

newtype NQueens = NQueens Int
  deriving Show

instance GAData NQueens where
  dataRange (NQueens n) = (0, n-1)
  repLength (NQueens n) = n
  fitness d@(NQueens n) queens = maxFitness d - vertCols - diagCols1 - diagCols2
    where
      calc l = sum $ map checkMult l
      checkMult x = if x > 1 then x-1 else 0
      posQueens = zip [0..] queens
      cols f = calc [length $ filter (f i) posQueens | i <- [(-n)..(n-1)]]
      vertCols = cols (\i (_, column) -> i == column)
      diagCols1 = cols (\i (row, column) -> row == column + i)
      diagCols2 = cols (\i (row, column) -> row == n - column + i)
  maxFitness (NQueens n) = fst $ quotRem (n*(n-1)) 2
  showSol (NQueens n) queens = intercalate "\n" $ map line queens
    where line x = intersperse ' ' $ (replicate x 'x') ++ "Q" ++ (replicate (n-x-1) 'x')
